http-backend: respect CONTENT_LENGTH for receive-pack
[git] / git-rebase--interactive.sh
1 # This shell script fragment is sourced by git-rebase to implement
2 # its interactive mode.  "git rebase --interactive" makes it easy
3 # to fix up commits in the middle of a series and rearrange commits.
4 #
5 # Copyright (c) 2006 Johannes E. Schindelin
6 #
7 # The original idea comes from Eric W. Biederman, in
8 # https://public-inbox.org/git/m1odwkyuf5.fsf_-_@ebiederm.dsl.xmission.com/
9 #
10 # The file containing rebase commands, comments, and empty lines.
11 # This file is created by "git rebase -i" then edited by the user.  As
12 # the lines are processed, they are removed from the front of this
13 # file and written to the tail of $done.
14 todo="$state_dir"/git-rebase-todo
15
16 # The rebase command lines that have already been processed.  A line
17 # is moved here when it is first handled, before any associated user
18 # actions.
19 done="$state_dir"/done
20
21 # The commit message that is planned to be used for any changes that
22 # need to be committed following a user interaction.
23 msg="$state_dir"/message
24
25 # The file into which is accumulated the suggested commit message for
26 # squash/fixup commands.  When the first of a series of squash/fixups
27 # is seen, the file is created and the commit message from the
28 # previous commit and from the first squash/fixup commit are written
29 # to it.  The commit message for each subsequent squash/fixup commit
30 # is appended to the file as it is processed.
31 #
32 # The first line of the file is of the form
33 #     # This is a combination of $count commits.
34 # where $count is the number of commits whose messages have been
35 # written to the file so far (including the initial "pick" commit).
36 # Each time that a commit message is processed, this line is read and
37 # updated.  It is deleted just before the combined commit is made.
38 squash_msg="$state_dir"/message-squash
39
40 # If the current series of squash/fixups has not yet included a squash
41 # command, then this file exists and holds the commit message of the
42 # original "pick" commit.  (If the series ends without a "squash"
43 # command, then this can be used as the commit message of the combined
44 # commit without opening the editor.)
45 fixup_msg="$state_dir"/message-fixup
46
47 # $rewritten is the name of a directory containing files for each
48 # commit that is reachable by at least one merge base of $head and
49 # $upstream. They are not necessarily rewritten, but their children
50 # might be.  This ensures that commits on merged, but otherwise
51 # unrelated side branches are left alone. (Think "X" in the man page's
52 # example.)
53 rewritten="$state_dir"/rewritten
54
55 dropped="$state_dir"/dropped
56
57 end="$state_dir"/end
58 msgnum="$state_dir"/msgnum
59
60 # A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
61 # GIT_AUTHOR_DATE that will be used for the commit that is currently
62 # being rebased.
63 author_script="$state_dir"/author-script
64
65 # When an "edit" rebase command is being processed, the SHA1 of the
66 # commit to be edited is recorded in this file.  When "git rebase
67 # --continue" is executed, if there are any staged changes then they
68 # will be amended to the HEAD commit, but only provided the HEAD
69 # commit is still the commit to be edited.  When any other rebase
70 # command is processed, this file is deleted.
71 amend="$state_dir"/amend
72
73 # For the post-rewrite hook, we make a list of rewritten commits and
74 # their new sha1s.  The rewritten-pending list keeps the sha1s of
75 # commits that have been processed, but not committed yet,
76 # e.g. because they are waiting for a 'squash' command.
77 rewritten_list="$state_dir"/rewritten-list
78 rewritten_pending="$state_dir"/rewritten-pending
79
80 # Work around Git for Windows' Bash whose "read" does not strip CRLF
81 # and leaves CR at the end instead.
82 cr=$(printf "\015")
83
84 empty_tree=$(git hash-object -t tree /dev/null)
85
86 strategy_args=${strategy:+--strategy=$strategy}
87 test -n "$strategy_opts" &&
88 eval '
89         for strategy_opt in '"$strategy_opts"'
90         do
91                 strategy_args="$strategy_args -X$(git rev-parse --sq-quote "${strategy_opt#--}")"
92         done
93 '
94
95 GIT_CHERRY_PICK_HELP="$resolvemsg"
96 export GIT_CHERRY_PICK_HELP
97
98 comment_char=$(git config --get core.commentchar 2>/dev/null)
99 case "$comment_char" in
100 '' | auto)
101         comment_char="#"
102         ;;
103 ?)
104         ;;
105 *)
106         comment_char=$(echo "$comment_char" | cut -c1)
107         ;;
108 esac
109
110 warn () {
111         printf '%s\n' "$*" >&2
112 }
113
114 # Output the commit message for the specified commit.
115 commit_message () {
116         git cat-file commit "$1" | sed "1,/^$/d"
117 }
118
119 orig_reflog_action="$GIT_REFLOG_ACTION"
120
121 comment_for_reflog () {
122         case "$orig_reflog_action" in
123         ''|rebase*)
124                 GIT_REFLOG_ACTION="rebase -i ($1)"
125                 export GIT_REFLOG_ACTION
126                 ;;
127         esac
128 }
129
130 last_count=
131 mark_action_done () {
132         sed -e 1q < "$todo" >> "$done"
133         sed -e 1d < "$todo" >> "$todo".new
134         mv -f "$todo".new "$todo"
135         new_count=$(( $(git stripspace --strip-comments <"$done" | wc -l) ))
136         echo $new_count >"$msgnum"
137         total=$(($new_count + $(git stripspace --strip-comments <"$todo" | wc -l)))
138         echo $total >"$end"
139         if test "$last_count" != "$new_count"
140         then
141                 last_count=$new_count
142                 eval_gettext "Rebasing (\$new_count/\$total)"; printf "\r"
143                 test -z "$verbose" || echo
144         fi
145 }
146
147 # Put the last action marked done at the beginning of the todo list
148 # again. If there has not been an action marked done yet, leave the list of
149 # items on the todo list unchanged.
150 reschedule_last_action () {
151         tail -n 1 "$done" | cat - "$todo" >"$todo".new
152         sed -e \$d <"$done" >"$done".new
153         mv -f "$todo".new "$todo"
154         mv -f "$done".new "$done"
155 }
156
157 append_todo_help () {
158         gettext "
159 Commands:
160 p, pick <commit> = use commit
161 r, reword <commit> = use commit, but edit the commit message
162 e, edit <commit> = use commit, but stop for amending
163 s, squash <commit> = use commit, but meld into previous commit
164 f, fixup <commit> = like \"squash\", but discard this commit's log message
165 x, exec <command> = run command (the rest of the line) using shell
166 d, drop <commit> = remove commit
167 l, label <label> = label current HEAD with a name
168 t, reset <label> = reset HEAD to a label
169 m, merge [-C <commit> | -c <commit>] <label> [# <oneline>]
170 .       create a merge commit using the original merge commit's
171 .       message (or the oneline, if no original merge commit was
172 .       specified). Use -c <commit> to reword the commit message.
173
174 These lines can be re-ordered; they are executed from top to bottom.
175 " | git stripspace --comment-lines >>"$todo"
176
177         if test $(get_missing_commit_check_level) = error
178         then
179                 gettext "
180 Do not remove any line. Use 'drop' explicitly to remove a commit.
181 " | git stripspace --comment-lines >>"$todo"
182         else
183                 gettext "
184 If you remove a line here THAT COMMIT WILL BE LOST.
185 " | git stripspace --comment-lines >>"$todo"
186         fi
187 }
188
189 make_patch () {
190         sha1_and_parents="$(git rev-list --parents -1 "$1")"
191         case "$sha1_and_parents" in
192         ?*' '?*' '?*)
193                 git diff --cc $sha1_and_parents
194                 ;;
195         ?*' '?*)
196                 git diff-tree -p "$1^!"
197                 ;;
198         *)
199                 echo "Root commit"
200                 ;;
201         esac > "$state_dir"/patch
202         test -f "$msg" ||
203                 commit_message "$1" > "$msg"
204         test -f "$author_script" ||
205                 get_author_ident_from_commit "$1" > "$author_script"
206 }
207
208 die_with_patch () {
209         echo "$1" > "$state_dir"/stopped-sha
210         git update-ref REBASE_HEAD "$1"
211         make_patch "$1"
212         die "$2"
213 }
214
215 exit_with_patch () {
216         echo "$1" > "$state_dir"/stopped-sha
217         git update-ref REBASE_HEAD "$1"
218         make_patch $1
219         git rev-parse --verify HEAD > "$amend"
220         gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
221         warn "$(eval_gettext "\
222 You can amend the commit now, with
223
224         git commit --amend \$gpg_sign_opt_quoted
225
226 Once you are satisfied with your changes, run
227
228         git rebase --continue")"
229         warn
230         exit $2
231 }
232
233 die_abort () {
234         apply_autostash
235         rm -rf "$state_dir"
236         die "$1"
237 }
238
239 has_action () {
240         test -n "$(git stripspace --strip-comments <"$1")"
241 }
242
243 is_empty_commit() {
244         tree=$(git rev-parse -q --verify "$1"^{tree} 2>/dev/null) || {
245                 sha1=$1
246                 die "$(eval_gettext "\$sha1: not a commit that can be picked")"
247         }
248         ptree=$(git rev-parse -q --verify "$1"^^{tree} 2>/dev/null) ||
249                 ptree=$empty_tree
250         test "$tree" = "$ptree"
251 }
252
253 is_merge_commit()
254 {
255         git rev-parse --verify --quiet "$1"^2 >/dev/null 2>&1
256 }
257
258 # Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
259 # GIT_AUTHOR_DATE exported from the current environment.
260 do_with_author () {
261         (
262                 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
263                 "$@"
264         )
265 }
266
267 git_sequence_editor () {
268         if test -z "$GIT_SEQUENCE_EDITOR"
269         then
270                 GIT_SEQUENCE_EDITOR="$(git config sequence.editor)"
271                 if [ -z "$GIT_SEQUENCE_EDITOR" ]
272                 then
273                         GIT_SEQUENCE_EDITOR="$(git var GIT_EDITOR)" || return $?
274                 fi
275         fi
276
277         eval "$GIT_SEQUENCE_EDITOR" '"$@"'
278 }
279
280 pick_one () {
281         ff=--ff
282
283         case "$1" in -n) sha1=$2; ff= ;; *) sha1=$1 ;; esac
284         case "$force_rebase" in '') ;; ?*) ff= ;; esac
285         output git rev-parse --verify $sha1 || die "$(eval_gettext "Invalid commit name: \$sha1")"
286
287         if is_empty_commit "$sha1"
288         then
289                 empty_args="--allow-empty"
290         fi
291
292         test -d "$rewritten" &&
293                 pick_one_preserving_merges "$@" && return
294         output eval git cherry-pick $allow_rerere_autoupdate $allow_empty_message \
295                         ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
296                         $signoff "$strategy_args" $empty_args $ff "$@"
297
298         # If cherry-pick dies it leaves the to-be-picked commit unrecorded. Reschedule
299         # previous task so this commit is not lost.
300         ret=$?
301         case "$ret" in [01]) ;; *) reschedule_last_action ;; esac
302         return $ret
303 }
304
305 pick_one_preserving_merges () {
306         fast_forward=t
307         case "$1" in
308         -n)
309                 fast_forward=f
310                 sha1=$2
311                 ;;
312         *)
313                 sha1=$1
314                 ;;
315         esac
316         sha1=$(git rev-parse $sha1)
317
318         if test -f "$state_dir"/current-commit && test "$fast_forward" = t
319         then
320                 while read current_commit
321                 do
322                         git rev-parse HEAD > "$rewritten"/$current_commit
323                 done <"$state_dir"/current-commit
324                 rm "$state_dir"/current-commit ||
325                         die "$(gettext "Cannot write current commit's replacement sha1")"
326         fi
327
328         echo $sha1 >> "$state_dir"/current-commit
329
330         # rewrite parents; if none were rewritten, we can fast-forward.
331         new_parents=
332         pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
333         if test "$pend" = " "
334         then
335                 pend=" root"
336         fi
337         while [ "$pend" != "" ]
338         do
339                 p=$(expr "$pend" : ' \([^ ]*\)')
340                 pend="${pend# $p}"
341
342                 if test -f "$rewritten"/$p
343                 then
344                         new_p=$(cat "$rewritten"/$p)
345
346                         # If the todo reordered commits, and our parent is marked for
347                         # rewriting, but hasn't been gotten to yet, assume the user meant to
348                         # drop it on top of the current HEAD
349                         if test -z "$new_p"
350                         then
351                                 new_p=$(git rev-parse HEAD)
352                         fi
353
354                         test $p != $new_p && fast_forward=f
355                         case "$new_parents" in
356                         *$new_p*)
357                                 ;; # do nothing; that parent is already there
358                         *)
359                                 new_parents="$new_parents $new_p"
360                                 ;;
361                         esac
362                 else
363                         if test -f "$dropped"/$p
364                         then
365                                 fast_forward=f
366                                 replacement="$(cat "$dropped"/$p)"
367                                 test -z "$replacement" && replacement=root
368                                 pend=" $replacement$pend"
369                         else
370                                 new_parents="$new_parents $p"
371                         fi
372                 fi
373         done
374         case $fast_forward in
375         t)
376                 output warn "$(eval_gettext "Fast-forward to \$sha1")"
377                 output git reset --hard $sha1 ||
378                         die "$(eval_gettext "Cannot fast-forward to \$sha1")"
379                 ;;
380         f)
381                 first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
382
383                 if [ "$1" != "-n" ]
384                 then
385                         # detach HEAD to current parent
386                         output git checkout $first_parent 2> /dev/null ||
387                                 die "$(eval_gettext "Cannot move HEAD to \$first_parent")"
388                 fi
389
390                 case "$new_parents" in
391                 ' '*' '*)
392                         test "a$1" = a-n && die "$(eval_gettext "Refusing to squash a merge: \$sha1")"
393
394                         # redo merge
395                         author_script_content=$(get_author_ident_from_commit $sha1)
396                         eval "$author_script_content"
397                         msg_content="$(commit_message $sha1)"
398                         # No point in merging the first parent, that's HEAD
399                         new_parents=${new_parents# $first_parent}
400                         merge_args="--no-log --no-ff"
401                         if ! do_with_author output eval \
402                                 git merge ${gpg_sign_opt:+$(git rev-parse \
403                                         --sq-quote "$gpg_sign_opt")} \
404                                 $allow_rerere_autoupdate "$merge_args" \
405                                 "$strategy_args" \
406                                 -m "$(git rev-parse --sq-quote "$msg_content")" \
407                                 "$new_parents"
408                         then
409                                 printf "%s\n" "$msg_content" > "$GIT_DIR"/MERGE_MSG
410                                 die_with_patch $sha1 "$(eval_gettext "Error redoing merge \$sha1")"
411                         fi
412                         echo "$sha1 $(git rev-parse HEAD^0)" >> "$rewritten_list"
413                         ;;
414                 *)
415                         output eval git cherry-pick $allow_rerere_autoupdate \
416                                 $allow_empty_message \
417                                 ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
418                                 "$strategy_args" "$@" ||
419                                 die_with_patch $sha1 "$(eval_gettext "Could not pick \$sha1")"
420                         ;;
421                 esac
422                 ;;
423         esac
424 }
425
426 this_nth_commit_message () {
427         n=$1
428         eval_gettext "This is the commit message #\${n}:"
429 }
430
431 skip_nth_commit_message () {
432         n=$1
433         eval_gettext "The commit message #\${n} will be skipped:"
434 }
435
436 update_squash_messages () {
437         if test -f "$squash_msg"; then
438                 mv "$squash_msg" "$squash_msg".bak || exit
439                 count=$(($(sed -n \
440                         -e "1s/^$comment_char[^0-9]*\([0-9][0-9]*\).*/\1/p" \
441                         -e "q" < "$squash_msg".bak)+1))
442                 {
443                         printf '%s\n' "$comment_char $(eval_ngettext \
444                                 "This is a combination of \$count commit." \
445                                 "This is a combination of \$count commits." \
446                                 $count)"
447                         sed -e 1d -e '2,/^./{
448                                 /^$/d
449                         }' <"$squash_msg".bak
450                 } >"$squash_msg"
451         else
452                 commit_message HEAD >"$fixup_msg" ||
453                 die "$(eval_gettext "Cannot write \$fixup_msg")"
454                 count=2
455                 {
456                         printf '%s\n' "$comment_char $(gettext "This is a combination of 2 commits.")"
457                         printf '%s\n' "$comment_char $(gettext "This is the 1st commit message:")"
458                         echo
459                         cat "$fixup_msg"
460                 } >"$squash_msg"
461         fi
462         case $1 in
463         squash)
464                 rm -f "$fixup_msg"
465                 echo
466                 printf '%s\n' "$comment_char $(this_nth_commit_message $count)"
467                 echo
468                 commit_message $2
469                 ;;
470         fixup)
471                 echo
472                 printf '%s\n' "$comment_char $(skip_nth_commit_message $count)"
473                 echo
474                 # Change the space after the comment character to TAB:
475                 commit_message $2 | git stripspace --comment-lines | sed -e 's/ /       /'
476                 ;;
477         esac >>"$squash_msg"
478 }
479
480 peek_next_command () {
481         git stripspace --strip-comments <"$todo" | sed -n -e 's/ .*//p' -e q
482 }
483
484 # A squash/fixup has failed.  Prepare the long version of the squash
485 # commit message, then die_with_patch.  This code path requires the
486 # user to edit the combined commit message for all commits that have
487 # been squashed/fixedup so far.  So also erase the old squash
488 # messages, effectively causing the combined commit to be used as the
489 # new basis for any further squash/fixups.  Args: sha1 rest
490 die_failed_squash() {
491         sha1=$1
492         rest=$2
493         mv "$squash_msg" "$msg" || exit
494         rm -f "$fixup_msg"
495         cp "$msg" "$GIT_DIR"/MERGE_MSG || exit
496         warn
497         warn "$(eval_gettext "Could not apply \$sha1... \$rest")"
498         die_with_patch $sha1 ""
499 }
500
501 flush_rewritten_pending() {
502         test -s "$rewritten_pending" || return
503         newsha1="$(git rev-parse HEAD^0)"
504         sed "s/$/ $newsha1/" < "$rewritten_pending" >> "$rewritten_list"
505         rm -f "$rewritten_pending"
506 }
507
508 record_in_rewritten() {
509         oldsha1="$(git rev-parse $1)"
510         echo "$oldsha1" >> "$rewritten_pending"
511
512         case "$(peek_next_command)" in
513         squash|s|fixup|f)
514                 ;;
515         *)
516                 flush_rewritten_pending
517                 ;;
518         esac
519 }
520
521 do_pick () {
522         sha1=$1
523         rest=$2
524         if test "$(git rev-parse HEAD)" = "$squash_onto"
525         then
526                 # Set the correct commit message and author info on the
527                 # sentinel root before cherry-picking the original changes
528                 # without committing (-n).  Finally, update the sentinel again
529                 # to include these changes.  If the cherry-pick results in a
530                 # conflict, this means our behaviour is similar to a standard
531                 # failed cherry-pick during rebase, with a dirty index to
532                 # resolve before manually running git commit --amend then git
533                 # rebase --continue.
534                 git commit --allow-empty --allow-empty-message --amend \
535                            --no-post-rewrite -n -q -C $sha1 $signoff &&
536                         pick_one -n $sha1 &&
537                         git commit --allow-empty --allow-empty-message \
538                                    --amend --no-post-rewrite -n -q -C $sha1 $signoff \
539                                    ${gpg_sign_opt:+"$gpg_sign_opt"} ||
540                                    die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
541         else
542                 pick_one $sha1 ||
543                         die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
544         fi
545 }
546
547 do_next () {
548         rm -f "$msg" "$author_script" "$amend" "$state_dir"/stopped-sha || exit
549         read -r command sha1 rest < "$todo"
550         case "$command" in
551         "$comment_char"*|''|noop|drop|d)
552                 mark_action_done
553                 ;;
554         "$cr")
555                 # Work around CR left by "read" (e.g. with Git for Windows' Bash).
556                 mark_action_done
557                 ;;
558         pick|p)
559                 comment_for_reflog pick
560
561                 mark_action_done
562                 do_pick $sha1 "$rest"
563                 record_in_rewritten $sha1
564                 ;;
565         reword|r)
566                 comment_for_reflog reword
567
568                 mark_action_done
569                 do_pick $sha1 "$rest"
570                 git commit --amend --no-post-rewrite ${gpg_sign_opt:+"$gpg_sign_opt"} \
571                         $allow_empty_message || {
572                         warn "$(eval_gettext "\
573 Could not amend commit after successfully picking \$sha1... \$rest
574 This is most likely due to an empty commit message, or the pre-commit hook
575 failed. If the pre-commit hook failed, you may need to resolve the issue before
576 you are able to reword the commit.")"
577                         exit_with_patch $sha1 1
578                 }
579                 record_in_rewritten $sha1
580                 ;;
581         edit|e)
582                 comment_for_reflog edit
583
584                 mark_action_done
585                 do_pick $sha1 "$rest"
586                 sha1_abbrev=$(git rev-parse --short $sha1)
587                 warn "$(eval_gettext "Stopped at \$sha1_abbrev... \$rest")"
588                 exit_with_patch $sha1 0
589                 ;;
590         squash|s|fixup|f)
591                 case "$command" in
592                 squash|s)
593                         squash_style=squash
594                         ;;
595                 fixup|f)
596                         squash_style=fixup
597                         ;;
598                 esac
599                 comment_for_reflog $squash_style
600
601                 test -f "$done" && has_action "$done" ||
602                         die "$(eval_gettext "Cannot '\$squash_style' without a previous commit")"
603
604                 mark_action_done
605                 update_squash_messages $squash_style $sha1
606                 author_script_content=$(get_author_ident_from_commit HEAD)
607                 echo "$author_script_content" > "$author_script"
608                 eval "$author_script_content"
609                 if ! pick_one -n $sha1
610                 then
611                         git rev-parse --verify HEAD >"$amend"
612                         die_failed_squash $sha1 "$rest"
613                 fi
614                 case "$(peek_next_command)" in
615                 squash|s|fixup|f)
616                         # This is an intermediate commit; its message will only be
617                         # used in case of trouble.  So use the long version:
618                         do_with_author output git commit --amend --no-verify -F "$squash_msg" \
619                                 ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
620                                 die_failed_squash $sha1 "$rest"
621                         ;;
622                 *)
623                         # This is the final command of this squash/fixup group
624                         if test -f "$fixup_msg"
625                         then
626                                 do_with_author git commit --amend --no-verify -F "$fixup_msg" \
627                                         ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
628                                         die_failed_squash $sha1 "$rest"
629                         else
630                                 cp "$squash_msg" "$GIT_DIR"/SQUASH_MSG || exit
631                                 rm -f "$GIT_DIR"/MERGE_MSG
632                                 do_with_author git commit --amend --no-verify -F "$GIT_DIR"/SQUASH_MSG -e \
633                                         ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
634                                         die_failed_squash $sha1 "$rest"
635                         fi
636                         rm -f "$squash_msg" "$fixup_msg"
637                         ;;
638                 esac
639                 record_in_rewritten $sha1
640                 ;;
641         x|"exec")
642                 read -r command rest < "$todo"
643                 mark_action_done
644                 eval_gettextln "Executing: \$rest"
645                 "${SHELL:-@SHELL_PATH@}" -c "$rest" # Actual execution
646                 status=$?
647                 # Run in subshell because require_clean_work_tree can die.
648                 dirty=f
649                 (require_clean_work_tree "rebase" 2>/dev/null) || dirty=t
650                 if test "$status" -ne 0
651                 then
652                         warn "$(eval_gettext "Execution failed: \$rest")"
653                         test "$dirty" = f ||
654                                 warn "$(gettext "and made changes to the index and/or the working tree")"
655
656                         warn "$(gettext "\
657 You can fix the problem, and then run
658
659         git rebase --continue")"
660                         warn
661                         if test $status -eq 127         # command not found
662                         then
663                                 status=1
664                         fi
665                         exit "$status"
666                 elif test "$dirty" = t
667                 then
668                         # TRANSLATORS: after these lines is a command to be issued by the user
669                         warn "$(eval_gettext "\
670 Execution succeeded: \$rest
671 but left changes to the index and/or the working tree
672 Commit or stash your changes, and then run
673
674         git rebase --continue")"
675                         warn
676                         exit 1
677                 fi
678                 ;;
679         *)
680                 warn "$(eval_gettext "Unknown command: \$command \$sha1 \$rest")"
681                 fixtodo="$(gettext "Please fix this using 'git rebase --edit-todo'.")"
682                 if git rev-parse --verify -q "$sha1" >/dev/null
683                 then
684                         die_with_patch $sha1 "$fixtodo"
685                 else
686                         die "$fixtodo"
687                 fi
688                 ;;
689         esac
690         test -s "$todo" && return
691
692         comment_for_reflog finish &&
693         newhead=$(git rev-parse HEAD) &&
694         case $head_name in
695         refs/*)
696                 message="$GIT_REFLOG_ACTION: $head_name onto $onto" &&
697                 git update-ref -m "$message" $head_name $newhead $orig_head &&
698                 git symbolic-ref \
699                   -m "$GIT_REFLOG_ACTION: returning to $head_name" \
700                   HEAD $head_name
701                 ;;
702         esac && {
703                 test ! -f "$state_dir"/verbose ||
704                         git diff-tree --stat $orig_head..HEAD
705         } &&
706         {
707                 test -s "$rewritten_list" &&
708                 git notes copy --for-rewrite=rebase < "$rewritten_list" ||
709                 true # we don't care if this copying failed
710         } &&
711         hook="$(git rev-parse --git-path hooks/post-rewrite)"
712         if test -x "$hook" && test -s "$rewritten_list"; then
713                 "$hook" rebase < "$rewritten_list"
714                 true # we don't care if this hook failed
715         fi &&
716                 warn "$(eval_gettext "Successfully rebased and updated \$head_name.")"
717
718         return 1 # not failure; just to break the do_rest loop
719 }
720
721 # can only return 0, when the infinite loop breaks
722 do_rest () {
723         while :
724         do
725                 do_next || break
726         done
727 }
728
729 expand_todo_ids() {
730         git rebase--helper --expand-ids
731 }
732
733 collapse_todo_ids() {
734         git rebase--helper --shorten-ids
735 }
736
737 # Switch to the branch in $into and notify it in the reflog
738 checkout_onto () {
739         GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name"
740         output git checkout $onto || die_abort "$(gettext "could not detach HEAD")"
741         git update-ref ORIG_HEAD $orig_head
742 }
743
744 get_missing_commit_check_level () {
745         check_level=$(git config --get rebase.missingCommitsCheck)
746         check_level=${check_level:-ignore}
747         # Don't be case sensitive
748         printf '%s' "$check_level" | tr 'A-Z' 'a-z'
749 }
750
751 # Initiate an action. If the cannot be any
752 # further action it  may exec a command
753 # or exit and not return.
754 #
755 # TODO: Consider a cleaner return model so it
756 # never exits and always return 0 if process
757 # is complete.
758 #
759 # Parameter 1 is the action to initiate.
760 #
761 # Returns 0 if the action was able to complete
762 # and if 1 if further processing is required.
763 initiate_action () {
764         case "$1" in
765         continue)
766                 if test ! -d "$rewritten"
767                 then
768                         exec git rebase--helper ${force_rebase:+--no-ff} $allow_empty_message \
769                                 --continue
770                 fi
771                 # do we have anything to commit?
772                 if git diff-index --cached --quiet HEAD --
773                 then
774                         # Nothing to commit -- skip this commit
775
776                         test ! -f "$GIT_DIR"/CHERRY_PICK_HEAD ||
777                         rm "$GIT_DIR"/CHERRY_PICK_HEAD ||
778                         die "$(gettext "Could not remove CHERRY_PICK_HEAD")"
779                 else
780                         if ! test -f "$author_script"
781                         then
782                                 gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
783                                 die "$(eval_gettext "\
784 You have staged changes in your working tree.
785 If these changes are meant to be
786 squashed into the previous commit, run:
787
788   git commit --amend \$gpg_sign_opt_quoted
789
790 If they are meant to go into a new commit, run:
791
792   git commit \$gpg_sign_opt_quoted
793
794 In both cases, once you're done, continue with:
795
796   git rebase --continue
797 ")"
798                         fi
799                         . "$author_script" ||
800                                 die "$(gettext "Error trying to find the author identity to amend commit")"
801                         if test -f "$amend"
802                         then
803                                 current_head=$(git rev-parse --verify HEAD)
804                                 test "$current_head" = $(cat "$amend") ||
805                                 die "$(gettext "\
806 You have uncommitted changes in your working tree. Please commit them
807 first and then run 'git rebase --continue' again.")"
808                                 do_with_author git commit --amend --no-verify -F "$msg" -e \
809                                         ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
810                                         die "$(gettext "Could not commit staged changes.")"
811                         else
812                                 do_with_author git commit --no-verify -F "$msg" -e \
813                                         ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
814                                         die "$(gettext "Could not commit staged changes.")"
815                         fi
816                 fi
817
818                 if test -r "$state_dir"/stopped-sha
819                 then
820                         record_in_rewritten "$(cat "$state_dir"/stopped-sha)"
821                 fi
822
823                 require_clean_work_tree "rebase"
824                 do_rest
825                 return 0
826                 ;;
827         skip)
828                 git rerere clear
829
830                 if test ! -d "$rewritten"
831                 then
832                         exec git rebase--helper ${force_rebase:+--no-ff} $allow_empty_message \
833                                 --continue
834                 fi
835                 do_rest
836                 return 0
837                 ;;
838         edit-todo)
839                 git stripspace --strip-comments <"$todo" >"$todo".new
840                 mv -f "$todo".new "$todo"
841                 collapse_todo_ids
842                 append_todo_help
843                 gettext "
844 You are editing the todo file of an ongoing interactive rebase.
845 To continue rebase after editing, run:
846     git rebase --continue
847
848 " | git stripspace --comment-lines >>"$todo"
849
850                 git_sequence_editor "$todo" ||
851                         die "$(gettext "Could not execute editor")"
852                 expand_todo_ids
853
854                 exit
855                 ;;
856         show-current-patch)
857                 exec git show REBASE_HEAD --
858                 ;;
859         *)
860                 return 1 # continue
861                 ;;
862         esac
863 }
864
865 setup_reflog_action () {
866         comment_for_reflog start
867
868         if test ! -z "$switch_to"
869         then
870                 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to"
871                 output git checkout "$switch_to" -- ||
872                         die "$(eval_gettext "Could not checkout \$switch_to")"
873
874                 comment_for_reflog start
875         fi
876 }
877
878 init_basic_state () {
879         orig_head=$(git rev-parse --verify HEAD) || die "$(gettext "No HEAD?")"
880         mkdir -p "$state_dir" || die "$(eval_gettext "Could not create temporary \$state_dir")"
881         rm -f "$(git rev-parse --git-path REBASE_HEAD)"
882
883         : > "$state_dir"/interactive || die "$(gettext "Could not mark as interactive")"
884         write_basic_state
885 }
886
887 init_revisions_and_shortrevisions () {
888         shorthead=$(git rev-parse --short $orig_head)
889         shortonto=$(git rev-parse --short $onto)
890         if test -z "$rebase_root"
891                 # this is now equivalent to ! -z "$upstream"
892         then
893                 shortupstream=$(git rev-parse --short $upstream)
894                 revisions=$upstream...$orig_head
895                 shortrevisions=$shortupstream..$shorthead
896         else
897                 revisions=$onto...$orig_head
898                 shortrevisions=$shorthead
899                 test -z "$squash_onto" ||
900                 echo "$squash_onto" >"$state_dir"/squash-onto
901         fi
902 }
903
904 complete_action() {
905         test -s "$todo" || echo noop >> "$todo"
906         test -z "$autosquash" || git rebase--helper --rearrange-squash || exit
907         test -n "$cmd" && git rebase--helper --add-exec-commands "$cmd"
908
909         todocount=$(git stripspace --strip-comments <"$todo" | wc -l)
910         todocount=${todocount##* }
911
912 cat >>"$todo" <<EOF
913
914 $comment_char $(eval_ngettext \
915         "Rebase \$shortrevisions onto \$shortonto (\$todocount command)" \
916         "Rebase \$shortrevisions onto \$shortonto (\$todocount commands)" \
917         "$todocount")
918 EOF
919         append_todo_help
920         gettext "
921         However, if you remove everything, the rebase will be aborted.
922
923         " | git stripspace --comment-lines >>"$todo"
924
925         if test -z "$keep_empty"
926         then
927                 printf '%s\n' "$comment_char $(gettext "Note that empty commits are commented out")" >>"$todo"
928         fi
929
930
931         has_action "$todo" ||
932                 return 2
933
934         cp "$todo" "$todo".backup
935         collapse_todo_ids
936         git_sequence_editor "$todo" ||
937                 die_abort "$(gettext "Could not execute editor")"
938
939         has_action "$todo" ||
940                 return 2
941
942         git rebase--helper --check-todo-list || {
943                 ret=$?
944                 checkout_onto
945                 exit $ret
946         }
947
948         expand_todo_ids
949
950         test -d "$rewritten" || test -n "$force_rebase" ||
951         onto="$(git rebase--helper --skip-unnecessary-picks)" ||
952         die "Could not skip unnecessary pick commands"
953
954         checkout_onto
955         if test ! -d "$rewritten"
956         then
957                 require_clean_work_tree "rebase"
958                 exec git rebase--helper ${force_rebase:+--no-ff} $allow_empty_message \
959                         --continue
960         fi
961         do_rest
962 }
963
964 git_rebase__interactive () {
965         initiate_action "$action"
966         ret=$?
967         if test $ret = 0; then
968                 return 0
969         fi
970
971         setup_reflog_action
972         init_basic_state
973
974         init_revisions_and_shortrevisions
975
976         git rebase--helper --make-script ${keep_empty:+--keep-empty} \
977                 ${rebase_merges:+--rebase-merges} \
978                 ${rebase_cousins:+--rebase-cousins} \
979                 $revisions ${restrict_revision+^$restrict_revision} >"$todo" ||
980         die "$(gettext "Could not generate todo list")"
981
982         complete_action
983 }
984
985 git_rebase__interactive__preserve_merges () {
986         initiate_action "$action"
987         ret=$?
988         if test $ret = 0; then
989                 return 0
990         fi
991
992         setup_reflog_action
993         init_basic_state
994
995         if test -z "$rebase_root"
996         then
997                 mkdir "$rewritten" &&
998                 for c in $(git merge-base --all $orig_head $upstream)
999                 do
1000                         echo $onto > "$rewritten"/$c ||
1001                                 die "$(gettext "Could not init rewritten commits")"
1002                 done
1003         else
1004                 mkdir "$rewritten" &&
1005                 echo $onto > "$rewritten"/root ||
1006                         die "$(gettext "Could not init rewritten commits")"
1007         fi
1008
1009         init_revisions_and_shortrevisions
1010
1011         format=$(git config --get rebase.instructionFormat)
1012         # the 'rev-list .. | sed' requires %m to parse; the instruction requires %H to parse
1013         git rev-list --format="%m%H ${format:-%s}" \
1014                 --reverse --left-right --topo-order \
1015                 $revisions ${restrict_revision+^$restrict_revision} | \
1016                 sed -n "s/^>//p" |
1017         while read -r sha1 rest
1018         do
1019                 if test -z "$keep_empty" && is_empty_commit $sha1 && ! is_merge_commit $sha1
1020                 then
1021                         comment_out="$comment_char "
1022                 else
1023                         comment_out=
1024                 fi
1025
1026                 if test -z "$rebase_root"
1027                 then
1028                         preserve=t
1029                         for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
1030                         do
1031                                 if test -f "$rewritten"/$p
1032                                 then
1033                                         preserve=f
1034                                 fi
1035                         done
1036                 else
1037                         preserve=f
1038                 fi
1039                 if test f = "$preserve"
1040                 then
1041                         touch "$rewritten"/$sha1
1042                         printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
1043                 fi
1044         done
1045
1046         # Watch for commits that been dropped by --cherry-pick
1047         mkdir "$dropped"
1048         # Save all non-cherry-picked changes
1049         git rev-list $revisions --left-right --cherry-pick | \
1050                 sed -n "s/^>//p" > "$state_dir"/not-cherry-picks
1051         # Now all commits and note which ones are missing in
1052         # not-cherry-picks and hence being dropped
1053         git rev-list $revisions |
1054         while read rev
1055         do
1056                 if test -f "$rewritten"/$rev &&
1057                    ! sane_grep "$rev" "$state_dir"/not-cherry-picks >/dev/null
1058                 then
1059                         # Use -f2 because if rev-list is telling us this commit is
1060                         # not worthwhile, we don't want to track its multiple heads,
1061                         # just the history of its first-parent for others that will
1062                         # be rebasing on top of it
1063                         git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$dropped"/$rev
1064                         sha1=$(git rev-list -1 $rev)
1065                         sane_grep -v "^[a-z][a-z]* $sha1" <"$todo" > "${todo}2" ; mv "${todo}2" "$todo"
1066                         rm "$rewritten"/$rev
1067                 fi
1068         done
1069
1070         complete_action
1071 }